Откат php

О виртуальном выделенном сервере

Модераторы: dobs, ArniXXX, hostess, pseudo

Сообщение
Автор
White Fang
Сообщения: 10
Зарегистрирован: Сб июл 03, 2010 12:10
Контактная информация:

Откат php

#1 Сообщение White Fang » Чт май 05, 2011 17:54

Доброго времени суток!

Народ, подскажите плиз как откатить php?
На серве стоит php-5.3.6-1.fc13 нужно 5.2.x....


White Fang
Сообщения: 10
Зарегистрирован: Сб июл 03, 2010 12:10
Контактная информация:

#3 Сообщение White Fang » Чт май 05, 2011 22:47

Спасибо конечно, но я умею пользоваться поисковиками, и не только гуглом.... Но нюанс в том - что реально все намного хуже чем написано там... Не получается сделать так как там написано. Пробовал делать так, как написано в статьях. Прошерстил инфу с 1й по 4ю ссылку....

dobs
HO Moderators
Сообщения: 2504
Зарегистрирован: Вс апр 09, 2006 14:42
Откуда: /home/Ukraine/Kiev
Контактная информация:

#4 Сообщение dobs » Пт май 06, 2011 13:30

Знач надо с исходников собирать, покопайте как прикрутить к испМанагеру suPHP там намного проще держать разные версии пхп

Код: Выделить всё

cd /tmp;
wget http://ua.php.net/get/php-5.2.17.tar.gz/from/ua2.php.net/mirror;
tar -xzvf php-5.2.17.tar.gz;
cd php-5.2.17;
./configure --prefix=/usr/bin/php-5.2 --exec-prefix=/usr/bin/php-5.2 --enable-cgi --disable-cli --with-png-dir=/usr/local --with-jpeg-dir=/usr/local --with-gd --enable-ftp --with-curl --with-zlib --enable-zip --with-iconv --enable-mbstring --with-mysql --with-freetype-dir=/usr/local --with-ttf --enable-gd-native-ttf --with-mysqli;
make;
make install;
Если без suPHP то походу путь /usr/bin/php-5.2 надо поменять кажись на /usr/

White Fang
Сообщения: 10
Зарегистрирован: Сб июл 03, 2010 12:10
Контактная информация:

#5 Сообщение White Fang » Пт май 06, 2011 13:38

НУ с исходников собрать - не проблема, не в первой :) Единственное что смущает - не начнутся ли проблемы на сайтах? Ладно... Будем разбираться... За наводку на suPHP - спасибо, буду копать...

dobs
HO Moderators
Сообщения: 2504
Зарегистрирован: Вс апр 09, 2006 14:42
Откуда: /home/Ukraine/Kiev
Контактная информация:

#6 Сообщение dobs » Пт май 06, 2011 13:47

Ну если есть сайты то лучше суПХП поставить а потом все настроить в нем, ток там надо быть по осторожней с CHMOD бо если на файле разрешено писать другим юзерам то выдаст 500 ошибку...

Вот пример рабочего конфига

Код: Выделить всё

[root@server server]# cat /etc/suphp.conf 
[global]
;Path to logfile
logfile=/var/log/suphp.log

;Loglevel
;loglevel=info
loglevel=error

;User Apache is running as
webserver_user=apache

;Path all scripts have to be in
docroot=/home/

;Path to chroot() to before executing script
;chroot=/mychroot

; Security options
allow_file_group_writeable=false
allow_file_others_writeable=false
allow_directory_group_writeable=false
allow_directory_others_writeable=false

;Check wheter script is within DOCUMENT_ROOT
check_vhost_docroot=true

;Send minor error messages to browser
errors_to_browser=true

;PATH environment variable
env_path=/bin:/usr/bin

;Umask to set, specify in octal notation
umask=0022

; Minimum UID
min_uid=0

; Minimum GID
min_gid=0

; Use correct permissions for mod_userdir sites
; handle_userdir=true

[handlers]
;Handler for php-scripts
application/x-httpd-php52="php:/usr/bin/php-5.2/bin/php-cgi"
application/x-httpd-php53="php:/usr/bin/php-cgi"
application/x-httpd-php53-light="php:/usr/bin/php-5.3-light/bin/php-cgi"

;Handler for CGI-scripts
x-suphp-cgi=execute:!self
Только вот
min_uid=0
min_gid=0
Надо для своих целей так что у Вас там должно быть 500 вместо 0
+ docroot=/home/ - там кажись надо /var/www/ или где там сайты дислоцируются...

Ну и сам вирт хост

Код: Выделить всё

<VirtualHost 127.0.0.1:80>

        ServerName domain.com
        ServerAlias www.domain.com 
        ServerAdmin webmaster@domain.com 
        DocumentRoot "/home/dobs/domains/domain.com/public_html"
        

        SuexecUserGroup dobs dobs
        CustomLog /var/log/httpd/domain.com|.log combined

        <Directory "/home/dobs/domains/domain.com/public_html">
                Options +FollowSymlinks -Indexes
                AllowOverride All
                Allow from all
                php_admin_flag engine ON
                php_admin_value sendmail_path '/usr/bin/sendmail -t -i -f dobs@domain.com'
                php_admin_value upload_tmp_dir "/home/dobs/domains/domain.com/tmp/"
                php_admin_value open_basedir "/home/dobs/domains/domain.com/"
                AddType application/x-httpd-php .php
        </Directory>

        suPHP_Engine ON
        suPHP_ConfigPath /home/panel/www/data/phpini/domain.com/
        suPHP_UserGroup dobs dobs
        
        suPHP_AddHandler application/x-httpd-php53-light
        AddHandler application/x-httpd-php53-light .inc .php .php3 .php4 .php5 .phtml .html
        
</VirtualHost>
suPHP_Engine ON - включает для хоста суПХП...
Последний раз редактировалось dobs Пт май 06, 2011 13:52, всего редактировалось 1 раз.

White Fang
Сообщения: 10
Зарегистрирован: Сб июл 03, 2010 12:10
Контактная информация:

#7 Сообщение White Fang » Пт май 06, 2011 13:52

Почитал я про суПЫХ - чет он меня не вчипитляет :(

Пытался все оформить через yum downgrade php - не хочет :(

Вот такой вопрос возник - а если пых удалить через yum remove <> , и потом с исходников установить нужную версию - чем это может быть чревато?



P.S. Собственно затеял то эту кашеварню из-за того что нужен ZendOptimizer, а он как известно не хочет работать с новым пыхом :( Возможно есть решение без раскройки пыха?

P.P.S. Извиняюсь за дотошность, больше привык с бунтой работать, на федоре немного путаюсь :(

dobs
HO Moderators
Сообщения: 2504
Зарегистрирован: Вс апр 09, 2006 14:42
Откуда: /home/Ukraine/Kiev
Контактная информация:

#8 Сообщение dobs » Пт май 06, 2011 13:57

можно попробовать yum remove php, по идеи сайты должны будут работать после удаления, но вот если перезагрузить апачь то уже не будет...
До перезагрузки апача скомпилить пых, после компиляции перезагрузить апач, если не фурычит то заново поставить php

Забыл, надо еще добавить к сборке пхп --with-libdir=lib64 бо это ж х64...

White Fang
Сообщения: 10
Зарегистрирован: Сб июл 03, 2010 12:10
Контактная информация:

#9 Сообщение White Fang » Пт май 06, 2011 14:07

ндя... лан, покурю маны, потом попробую, как наберусь смелости.. о результатах отпишусь обязательно...

White Fang
Сообщения: 10
Зарегистрирован: Сб июл 03, 2010 12:10
Контактная информация:

#10 Сообщение White Fang » Пт май 06, 2011 19:34

Доброго времени суток!
Пытаюсь вручную поставить ПЫХ, при конфигурации получаю:

Код: Выделить всё

# ./configure --with-libdir=lib64
creating cache ./config.cache
checking for Cygwin environment... no
checking for mingw32 environment... no
checking for egrep... grep -E
checking for a sed that does not truncate output... /bin/sed
checking host system type... x86_64-unknown-linux-gnu
checking target system type... x86_64-unknown-linux-gnu
Updated main/php_version.h
checking for gcc... no
checking for cc... no
configure: error: no acceptable cc found in $PATH
подскажите что не так?

dobs
HO Moderators
Сообщения: 2504
Зарегистрирован: Вс апр 09, 2006 14:42
Откуда: /home/Ukraine/Kiev
Контактная информация:

#11 Сообщение dobs » Пт май 06, 2011 22:46

Надо было

Код: Выделить всё

./configure --prefix=/usr/bin/php-5.2 --exec-prefix=/usr/bin/php-5.2 --enable-cgi --disable-cli --with-png-dir=/usr/local --with-jpeg-dir=/usr/local --with-gd --enable-ftp --with-curl --with-zlib --enable-zip --with-iconv --enable-mbstring --with-mysql --with-freetype-dir=/usr/local --with-ttf --enable-gd-native-ttf --with-mysqli --with-libdir=lib64;

White Fang
Сообщения: 10
Зарегистрирован: Сб июл 03, 2010 12:10
Контактная информация:

#12 Сообщение White Fang » Сб май 07, 2011 00:45

нет... там надо было просто gcc установить :) а потом еще и make

Код: Выделить всё

# yum install gcc

# yum install make
разобрался, установил, но пришлось снова ставить php-5.3, позже буду разбираться...

LiMTeaM
Сообщения: 80
Зарегистрирован: Сб май 28, 2011 10:09

#13 Сообщение LiMTeaM » Пн июн 06, 2011 03:08

Код: Выделить всё

bash-4.1# ./configure --prefix=/usr/php-5.2 --exec-prefix=/usr/php-5.2 --enable-cgi --disable-cli --with-png-dir=/usr/local --with-jpeg-dir=/usr/local --with-gd --enable-ftp --with-curl --with-zlib --enable-zip --with-iconv --enable-mbstring --with-mysql --with-freetype-dir=/usr/local --with-ttf --enable-gd-native-ttf --with-mysqli --with-libdir=lib64;
loading cache ./config.cache
checking for Cygwin environment... no
checking for mingw32 environment... no
checking for egrep... grep -E
checking for a sed that does not truncate output... /bin/sed
checking host system type... x86_64-unknown-linux-gnu
checking target system type... x86_64-unknown-linux-gnu
checking for gcc... gcc
checking whether the C compiler (gcc  ) works... no
configure: error: installation or configuration problem: C compiler cannot create executables.

GCC установлен:

Код: Выделить всё

bash-4.1# yum install gcc
fedora/metalink                                                                                                                     |  32 kB     00:00
rpmforge                                                                                                                            |  975 B     00:00
rpmfusion-free                                                                                                                      | 2.7 kB     00:00
rpmfusion-free-updates                                                                                                              | 3.3 kB     00:00
updates/metalink                                                                                                                    |  26 kB     00:00
Setting up Install Process
Package gcc-4.5.1-4.fc14.x86_64 already installed and latest version
Nothing to do

pseudo
HO Support
Сообщения: 136
Зарегистрирован: Чт май 20, 2010 10:24
Откуда: kyiv.ua
Контактная информация:

#14 Сообщение pseudo » Пн июн 06, 2011 12:40

Окрім gcc треба встановити, як мінімум, glibc-devel.
Лучше обрез в руках, чем Калашников на складе

LiMTeaM
Сообщения: 80
Зарегистрирован: Сб май 28, 2011 10:09

#15 Сообщение LiMTeaM » Пн июн 06, 2011 13:13

pseudo писал(а):Окрім gcc треба встановити, як мінімум, glibc-devel.
Этот пакет также установлен:

Setting up Install Process
Package glibc-devel-2.13-1.x86_64 already installed and latest version
Nothing to do
bash-4.1#

Ответить